function [ A_diag_dom_vert_s ] = A_diag_dom_s_vertical_noexch_fun(m_regr,combos_s_all,combos_p_all,temp_mat2)
% Imposes 'vertical' diagonal dominance (one by one) on the jacobian of sigma inverse
% wrt p

A_diag_dom_vert_s = [];

%% good 1

parfor h=1:m_regr(6)+1           % for any price_outside
    for k=1:m_regr(5)+1           % for any income
        for s=1:size(combos_s_all,1)          % loop over combos of shares
            for p=1:size(combos_p_all,1)          % loop over combos of prices
                
                combos_s = combos_s_all(s,:);
                combos_p = combos_p_all(p,:);
                
                combos_s_c = num2cell(combos_s_all(s,:));
                combos_p_c = num2cell(combos_p_all(p,:));
                
                j=2;           % other good wrt whose derivative we compare the derivative wrt own good
                    
                    indices = [2 1];
                    
                    combos_s_reord = combos_s(indices);
                    combos_p_reord = combos_p(indices);
                    
                    combos_s_reord_c = num2cell(combos_s_reord);
                    combos_p_reord_c = num2cell(combos_p_reord);
                    
                    %%
                    
                    if combos_s(1)<m_regr(1)+1
                        
                        temp = temp_mat2;
                        
                        temp_ind = combos_s;
                        vec = zeros(size(temp_ind));
                        vec(1) = +1;
                        temp_ind2 = temp_ind + vec;
                        temp_ind2_c = num2cell(temp_ind2);
                        
                        temp(temp_ind2_c{:},combos_p_c{:},k,h,1) = temp(temp_ind2_c{:},combos_p_c{:},k,h,1) - 1;        % minus derivative of good 1 wrt own price
                        temp(combos_s_c{:},combos_p_c{:},k,h,1) = temp(combos_s_c{:},combos_p_c{:},k,h,1) + 1;
                        
                        temp_ind = combos_s_reord;
                        vec = zeros(size(temp_ind));
                        vec(2) = +1;
                        temp_ind2 = temp_ind + vec;
                        temp_ind2_c = num2cell(temp_ind2);
                        
                        temp(temp_ind2_c{:},combos_p_reord_c{:},k,h,j) = temp(temp_ind2_c{:},combos_p_reord_c{:},k,h,j) + 1;        % derivative of j-th good wrt 1st good's price
                        temp(combos_s_reord_c{:},combos_p_reord_c{:},k,h,j) = temp(combos_s_reord_c{:},combos_p_reord_c{:},k,h,j) - 1;
                        
                        A_diag_dom_vert_s = [A_diag_dom_vert_s;
                            reshape(temp,1,numel(temp))];
                        
                    end
                    
                    %%
                    
                    if combos_s(1)>1
                        
                        temp = temp_mat2;
                        
                        temp_ind = combos_s;
                        vec = zeros(size(temp_ind));
                        vec(1) = -1;
                        temp_ind2 = temp_ind + vec;
                        temp_ind2_c = num2cell(temp_ind2);
                        
                        temp(temp_ind2_c{:},combos_p_c{:},k,h,1) = temp(temp_ind2_c{:},combos_p_c{:},k,h,1) + 1;        % minus the derivative of good 1 wrt own price
                        temp(combos_s_c{:},combos_p_c{:},k,h,1) = temp(combos_s_c{:},combos_p_c{:},k,h,1) - 1;
                        
                        temp_ind = combos_s_reord;
                        vec = zeros(size(temp_ind));
                        vec(2) = -1;
                        temp_ind2 = temp_ind + vec;
                        temp_ind2_c = num2cell(temp_ind2);
                        
                        temp(temp_ind2_c{:},combos_p_reord_c{:},k,h,j) = temp(temp_ind2_c{:},combos_p_reord_c{:},k,h,j) - 1;        % derivative of j-th good wrt 1st good's price
                        temp(combos_s_reord_c{:},combos_p_reord_c{:},k,h,j) = temp(combos_s_reord_c{:},combos_p_reord_c{:},k,h,j) + 1;
                        
                        A_diag_dom_vert_s = [A_diag_dom_vert_s;
                            reshape(temp,1,numel(temp))];
                        
                    end
            end
        end
    end
end

%% good 2

parfor h=1:m_regr(6)+1           % for any price_outside
    for k=1:m_regr(5)+1           % for any income
        for s=1:size(combos_s_all,1)          % loop over combos of shares
            for p=1:size(combos_p_all,1)          % loop over combos of prices
                
                combos_s = combos_s_all(s,:);
                combos_p = combos_p_all(p,:);
                
                combos_s_c = num2cell(combos_s_all(s,:));
                combos_p_c = num2cell(combos_p_all(p,:));
                
                j=1;           % other good wrt whose derivative we compare the derivative wrt own good
                    
                    indices = [2 1];
                    
                    combos_s_reord = combos_s(indices);
                    combos_p_reord = combos_p(indices);
                    
                    combos_s_reord_c = num2cell(combos_s_reord);
                    combos_p_reord_c = num2cell(combos_p_reord);
                    
                    %%
                    
                    if combos_s(1)<m_regr(1)+1
                        
                        temp = temp_mat2;
                        
                        temp_ind = combos_s;
                        vec = zeros(size(temp_ind));
                        vec(1) = +1;
                        temp_ind2 = temp_ind + vec;
                        temp_ind2_c = num2cell(temp_ind2);
                        
                        temp(temp_ind2_c{:},combos_p_c{:},k,h,2) = temp(temp_ind2_c{:},combos_p_c{:},k,h,2) - 1;        % minus derivative of good 2 wrt own price
                        temp(combos_s_c{:},combos_p_c{:},k,h,2) = temp(combos_s_c{:},combos_p_c{:},k,h,2) + 1;
                        
                        temp_ind = combos_s_reord;
                        vec = zeros(size(temp_ind));
                        vec(2) = +1;
                        temp_ind2 = temp_ind + vec;
                        temp_ind2_c = num2cell(temp_ind2);
                        
                        temp(temp_ind2_c{:},combos_p_reord_c{:},k,h,j) = temp(temp_ind2_c{:},combos_p_reord_c{:},k,h,j) + 1;        % derivative of j-th good wrt 2nd good's price
                        temp(combos_s_reord_c{:},combos_p_reord_c{:},k,h,j) = temp(combos_s_reord_c{:},combos_p_reord_c{:},k,h,j) - 1;
                        
                        A_diag_dom_vert_s = [A_diag_dom_vert_s;
                            reshape(temp,1,numel(temp))];
                        
                    end
                    
                    %%
                    
                    if combos_s(1)>1
                        
                        temp = temp_mat2;
                        
                        temp_ind = combos_s;
                        vec = zeros(size(temp_ind));
                        vec(1) = -1;
                        temp_ind2 = temp_ind + vec;
                        temp_ind2_c = num2cell(temp_ind2);
                        
                        temp(temp_ind2_c{:},combos_p_c{:},k,h,2) = temp(temp_ind2_c{:},combos_p_c{:},k,h,2) + 1;        % minus the derivative of good 2 wrt own price
                        temp(combos_s_c{:},combos_p_c{:},k,h,2) = temp(combos_s_c{:},combos_p_c{:},k,h,2) - 1;
                        
                        temp_ind = combos_s_reord;
                        vec = zeros(size(temp_ind));
                        vec(2) = -1;
                        temp_ind2 = temp_ind + vec;
                        temp_ind2_c = num2cell(temp_ind2);
                        
                        temp(temp_ind2_c{:},combos_p_reord_c{:},k,h,j) = temp(temp_ind2_c{:},combos_p_reord_c{:},k,h,j) - 1;        % derivative of j-th good wrt 2nd good's price
                        temp(combos_s_reord_c{:},combos_p_reord_c{:},k,h,j) = temp(combos_s_reord_c{:},combos_p_reord_c{:},k,h,j) + 1;
                        
                        A_diag_dom_vert_s = [A_diag_dom_vert_s;
                            reshape(temp,1,numel(temp))];
                        
                    end
            end
        end
    end
end

A_diag_dom_vert_s = unique(A_diag_dom_vert_s,'rows');
A_diag_dom_vert_s = setdiff(A_diag_dom_vert_s,zeros(1,size(A_diag_dom_vert_s,2)),'rows');

end

