function [ A_symmetry ] = A_symmetry_noexch_fun_2(m_regr,combos_all)

%% Impose symmetry wrt s (i.e. delta) for any given vector of prices

J = 2;
n_Bcoeff = size(combos_all,1);

combos_s_p = unique(combos_all(:,1:2*J),'rows');
n_Bcoeff_s_p = size(combos_s_p,1);
A_symmetry = [];

parfor h=1:m_regr(6)+1           % for any price_outside
    for k=1:m_regr(5)+1           % for any income
        for w=1:n_Bcoeff_s_p           % combos for s and p
            for j=2:J                 % good wrt which we take the increment
                
                ind_reorder = [j setdiff(1:J,j)];
                [~,position] = sort(ind_reorder);     % position(r) gives the position of the r-th good in the indices vector
                
                combos_s = double(combos_all(w,1:J));
                combos_p = double(combos_all(w,J+1:2*J));
                temp_ind = [double(combos_s_p(w,:)) k h];
                
                combos_s_reord = combos_s(ind_reorder);
                combos_p_reord = combos_p(ind_reorder);
                temp_ind_reord = [rep2unique([combos_s_reord combos_p_reord],J) k h];
                
                %%
                
                if combos_s(j)<m_regr(j)+1 && combos_s(1)<m_regr(1)+1
                    
                    temp_own = zeros(1,n_Bcoeff);
                    temp_j = zeros(1,n_Bcoeff);
                    temp_mat = zeros(1,n_Bcoeff,J);
                    
                    % derivative of own inverse sigma wrt s_j
                    
                    combos_s_plus1 = combos_s + [zeros(1,j-1) 1 zeros(1,J-j)];
                    temp_ind2 = rep2unique([combos_s_plus1 combos_p],J);
                    temp_ind3 = [temp_ind2 k h];
                    
                    temp_own(ismember(combos_all,temp_ind,'rows')) = temp_own(ismember(combos_all,temp_ind,'rows')) - 1;
                    temp_own(ismember(combos_all,temp_ind3,'rows')) = temp_own(ismember(combos_all,temp_ind3,'rows')) + 1;
                    
                    % derivative of j inverse sigma wrt own
                    
                    vec = zeros(1,J);
                    vec(position(1)) = 1;
                    combos_s_plus1 = combos_s_reord + vec;
                    temp_ind2 = rep2unique([combos_s_plus1 combos_p_reord],J);
                    temp_ind3 = [temp_ind2 k h];
                    
                    temp_j(ismember(combos_all,temp_ind_reord,'rows')) = temp_j(ismember(combos_all,temp_ind_reord,'rows')) + 1;
                    temp_j(ismember(combos_all,temp_ind3,'rows')) = temp_j(ismember(combos_all,temp_ind3,'rows')) - 1;
                    
                    temp_mat(:,:,1) = temp_own;
                    temp_mat(:,:,j) = temp_j;
                    
                    A_symmetry = [A_symmetry;
                        reshape(temp_mat,1,numel(temp_mat))];
                    
                end
                
                %%
                
                if combos_s(j)>1 && combos_s(1)>1
                    
                    temp_own = zeros(1,n_Bcoeff);
                    temp_j = zeros(1,n_Bcoeff);
                    temp_mat = zeros(1,n_Bcoeff,J);
                    
                    % derivative of own inverse sigma wrt s_j
                    
                    combos_s_minus1 = combos_s + [zeros(1,j-1) -1 zeros(1,J-j)];
                    temp_ind2 = rep2unique([combos_s_minus1 combos_p],J);
                    temp_ind3 = [temp_ind2 k h];
                    
                    temp_own(ismember(combos_all,temp_ind,'rows')) = temp_own(ismember(combos_all,temp_ind,'rows')) + 1;
                    temp_own(ismember(combos_all,temp_ind3,'rows')) = temp_own(ismember(combos_all,temp_ind3,'rows')) - 1;
                    
                    % derivative of j inverse sigma wrt own
                    
                    vec = zeros(1,J);
                    vec(position(1)) = 1;
                    combos_s_minus1 = combos_s_reord - vec;
                    temp_ind2 = rep2unique([combos_s_minus1 combos_p_reord],J);
                    temp_ind3 = [temp_ind2 k h];
                    
                    temp_j(ismember(combos_all,temp_ind_reord,'rows')) = temp_j(ismember(combos_all,temp_ind_reord,'rows')) - 1;
                    temp_j(ismember(combos_all,temp_ind3,'rows')) = temp_j(ismember(combos_all,temp_ind3,'rows')) + 1;
                    
                    temp_mat(:,:,1) = temp_own;
                    temp_mat(:,:,j) = temp_j;
                    
                    A_symmetry = [A_symmetry;
                        reshape(temp_mat,1,numel(temp_mat))];
                    
                end
                
                %%
                
                if combos_s(j)>1 && combos_s(1)<m_regr(1)+1
                    
                    temp_own = zeros(1,n_Bcoeff);
                    temp_j = zeros(1,n_Bcoeff);
                    temp_mat = zeros(1,n_Bcoeff,J);
                    
                    % derivative of own inverse sigma wrt s_j
                    
                    combos_s_minus1 = combos_s + [zeros(1,j-1) -1 zeros(1,J-j)];
                    temp_ind2 = rep2unique([combos_s_minus1 combos_p],J);
                    temp_ind3 = [temp_ind2 k h];
                    
                    temp_own(ismember(combos_all,temp_ind,'rows')) = temp_own(ismember(combos_all,temp_ind,'rows')) + 1;
                    temp_own(ismember(combos_all,temp_ind3,'rows')) = temp_own(ismember(combos_all,temp_ind3,'rows')) - 1;
                    
                    % derivative of j inverse sigma wrt own
                    
                    vec = zeros(1,J);
                    vec(position(1)) = 1;
                    combos_s_plus1 = combos_s_reord + vec;
                    temp_ind2 = rep2unique([combos_s_plus1 combos_p_reord],J);
                    temp_ind3 = [temp_ind2 k h];
                    
                    temp_j(ismember(combos_all,temp_ind_reord,'rows')) = temp_j(ismember(combos_all,temp_ind_reord,'rows')) + 1;
                    temp_j(ismember(combos_all,temp_ind3,'rows')) = temp_j(ismember(combos_all,temp_ind3,'rows')) - 1;
                    
                    temp_mat(:,:,1) = temp_own;
                    temp_mat(:,:,j) = temp_j;
                    
                    A_symmetry = [A_symmetry;
                        reshape(temp_mat,1,numel(temp_mat))];
                    
                end
                
                %%
                
                if combos_s(j)<m_regr(j)+1 && combos_s(1)>1
                    
                    temp_own = zeros(1,n_Bcoeff);
                    temp_j = zeros(1,n_Bcoeff);
                    temp_mat = zeros(1,n_Bcoeff,J);
                    
                    % derivative of own inverse sigma wrt s_j
                    
                    combos_s_plus1 = combos_s + [zeros(1,j-1) 1 zeros(1,J-j)];
                    temp_ind2 = rep2unique([combos_s_plus1 combos_p],J);
                    temp_ind3 = [temp_ind2 k h];
                    
                    temp_own(ismember(combos_all,temp_ind,'rows')) = temp_own(ismember(combos_all,temp_ind,'rows')) - 1;
                    temp_own(ismember(combos_all,temp_ind3,'rows')) = temp_own(ismember(combos_all,temp_ind3,'rows')) + 1;
                    
                    % derivative of j inverse sigma wrt own
                    
                    vec = zeros(1,J);
                    vec(position(1)) = 1;
                    combos_s_minus1 = combos_s_reord - vec;
                    temp_ind2 = rep2unique([combos_s_minus1 combos_p_reord],J);
                    temp_ind3 = [temp_ind2 k h];
                    
                    temp_j(ismember(combos_all,temp_ind_reord,'rows')) = temp_j(ismember(combos_all,temp_ind_reord,'rows')) - 1;
                    temp_j(ismember(combos_all,temp_ind3,'rows')) = temp_j(ismember(combos_all,temp_ind3,'rows')) + 1;
                    
                    temp_mat(:,:,1) = temp_own;
                    temp_mat(:,:,j) = temp_j;
                    
                    A_symmetry = [A_symmetry;
                        reshape(temp_mat,1,numel(temp_mat))];
                end
            end
        end
    end
    %k
end

A_symmetry = unique(A_symmetry,'rows');
A_symmetry = setdiff(A_symmetry,zeros(1,size(A_symmetry,2)),'rows');

end