function [csi,s1,s2] = csi_fixedtol(theta_BCS,data_trans_both,s_vec,T,J,csi_logit,theta_logit)
% This function computes the mean utility level

% in this code, the tolerance level is fixed (vs Nevo's code where the tolerance gets slacker as the number of iterations grows)

% load('C:\Users\Giovanni\Dropbox\Nonparametric Demand\comparison\BLP\mvalold.mat')
% % load('mvalold.mat')

constant = theta_BCS(1:2);
coeff_p_income = theta_BCS(3);
coeff_p_out = theta_BCS(4);
coeff_x_outf = theta_BCS(5);
coeff_x_usda = theta_BCS(6);
coeff_p = theta_BCS(7:8);
weight = theta_BCS(9);

csi_old = csi_logit;
theta_old = theta_logit;

if max(abs(theta_BCS-theta_old)) < 0.01
    tol = 1e-10;
    flag = 0;
else
    tol = 1e-10;
    flag = 1;
end

norm = 1;
avgnorm = 1;
% cc = zeros(1,1000000);
i = 0;
while norm > tol
    % the following two lines are equivalent; however, the latter saves on the number of exponents
    % computed at therefore speeds up the computation by 5-10%
    %  mval = mvalold + log(s_jt) - log(mktsh(mvalold,expmu));
    
    temp1 = kron(eye(2),ones(T,1))*constant' + coeff_p(1)*data_trans_both.p_own + coeff_x_outf*data_trans_both.x_outf + coeff_x_usda*data_trans_both.x_usda_lettuce_2 +...
            coeff_p_income*data_trans_both.p_own.*data_trans_both.income + coeff_p_out*data_trans_both.p_out_avg + csi_old;
    temp2 = kron(eye(2),ones(T,1))*constant' + coeff_p(2)*data_trans_both.p_own + coeff_x_outf*data_trans_both.x_outf + coeff_x_usda*data_trans_both.x_usda_lettuce_2 +... 
            coeff_p_income*data_trans_both.p_own.*data_trans_both.income + coeff_p_out*data_trans_both.p_out_avg + csi_old;
    
    temp_exp1 = exp(temp1);
    temp_exp2 = exp(temp2);
    
    den1 = 1+sum(reshape(temp_exp1,[T,J]),2);
    den2 = 1+sum(reshape(temp_exp2,[T,J]),2);
    
    s1 = temp_exp1./(repmat(den1,[J,1]));
    s2 = temp_exp2./(repmat(den2,[J,1]));
    
    s_vec_model = s1*weight + s2*(1-weight);
    
    csi = csi_old + log(s_vec) - log(s_vec_model);
%     csi = csi_old.*s_vec./s_vec_model;       % T*J - by - 1
    
    t = abs(csi-csi_old);
    norm = max(t);
    avgnorm = mean(t);
    csi_old = csi;
    i = i + 1;
%     cc(i) = max(isnan(csi));
end
disp(['# of iterations for delta convergence:  ' num2str(i)])

if flag == 1 && max(isnan(csi)) < 1
    csi_old = csi;
    theta_old = theta_BCS;
%     save('mvalold.mat','mvalold','oldt2')
end

f = csi;

% f = log(csi);

end
