function [ p_eq,p_eq_norm,flag ] = eq_price_est_foc_fun_multi_nevo_BCS(mc_1,mc_2,csi_1,csi_2,x_outf_norm,x_usda_norm,p_1_norm,p_2_norm,income_norm,p_out_norm,data_price,...
                                                          theta_BCS,option_prices,nx0)

% NB: profit function                                                       
                                                      
p0 = [p_1_norm,p_2_norm];

fun = @(p) fun_foc_nevo_BCS(p,mc_1,mc_2,csi_1,csi_2,x_outf_norm,x_usda_norm,income_norm,p_out_norm,data_price,...
                         theta_BCS,option_prices);
                     
options = optimoptions('fsolve','Display','none','FunctionTolerance',10^-6,'OptimalityTolerance',10^-6);
                     
initial_points_mat = p0;

for i=2:nx0
    
    initial_points_mat = [initial_points_mat;
                          p0*(1+(i-1)/nx0);
                          p0*(1-(i-1)/nx0)];
                      
end

p_eq_norm_temp = zeros(size(initial_points_mat,1),2); 
flag_temp = zeros(size(initial_points_mat,1),1); 

for i=1:size(initial_points_mat,1)
    
    [p_eq_norm_temp(i,:),~,flag_temp(i)] = fsolve(fun,initial_points_mat(i,:),options);

end

% take solution (among the ones with positive flag) that is closest to
% initial price p0

if isempty(find(flag_temp>0))==0
    
    flag = 1;
    
    temp_flag = find(flag_temp>0);
    
    [~,temp_close] = min(sum(abs(p0-p_eq_norm_temp(temp_flag,:)),2));
    
    p_eq_norm = p_eq_norm_temp(temp_flag(temp_close),:);
    
    p_eq =  normalize_p_inv_fun(p_eq_norm,data_price,option_prices);

else
   
    flag = 0;
    
    [~,temp_close] = min(sum(abs(p0-p_eq_norm_temp),2));
    
    p_eq_norm = p_eq_norm_temp(temp_close,:);
    
    p_eq =  normalize_p_inv_fun(p_eq_norm,data_price,option_prices);
    
end


end