function [ p_eq,p_eq_norm,flag ] = eq_price_est_foc_fun_multi_nevo_NPD(mc,delta,income,p_out,data_price,theta_sigma,combos_all,m_regr,option_prices,p0,nx0)

% NB: profit function     

warning('off','MATLAB:illConditionedMatrix')
                                                     
fun = @(p) fun_foc_nevo_NPD(p,mc(1),mc(2),delta(1),delta(2),income,p_out,data_price,theta_sigma,combos_all,m_regr,option_prices);
                     
options = optimoptions('fsolve','Display','none','FunctionTolerance',10^-10,'OptimalityTolerance',10^-10,'StepTolerance',10^-10);

initial_points_mat = p0;

for i=2:nx0
    
    initial_points_mat = [initial_points_mat;
                          p0*(1+(i-1)/nx0);
                          p0*(1-(i-1)/nx0)];
                      
end

p_eq_norm_temp = zeros(size(initial_points_mat,1),2); 
flag_temp = zeros(size(initial_points_mat,1),1); 

for i=1:size(initial_points_mat,1)
    
    if all(isnan(fun(initial_points_mat(i,:)))==0) && all(isinf(fun(initial_points_mat(i,:)))==0)
    
        [p_eq_norm_temp(i,:),~,flag_temp(i)] = fsolve(fun,initial_points_mat(i,:),options);
    
    end

end

% take solution (among the ones with positive flag) that is closest to
% initial price p0

if isempty(find(flag_temp>0))==0
    
    flag = 1;
    
    temp_flag = find(flag_temp>0);
    
    [~,temp_close] = min(sum(abs(p0-p_eq_norm_temp(temp_flag,:)),2));
    
    p_eq_norm = p_eq_norm_temp(temp_flag(temp_close),:);
    
    p_eq =  normalize_p_inv_fun(p_eq_norm,data_price,option_prices);

else
   
    flag = 0;
    
    [~,temp_close] = min(sum(abs(p0-p_eq_norm_temp),2));
    
    p_eq_norm = p_eq_norm_temp(temp_close,:);
    
    p_eq =  normalize_p_inv_fun(p_eq_norm,data_price,option_prices);
    
end

end