function [ fun,grad ] = estimation_criterion(x,data_trans,w_mat,B_s,B_IV_final)

B_s_1 = double(B_s{1});
B_IV_final_1 = double(B_IV_final{1});
w_mat_1 = double(w_mat{1});

B_s_2 = double(B_s{2});
B_IV_final_2 = double(B_IV_final{2});
w_mat_2 = double(w_mat{2});

theta_1 = reshape(x(1:size(B_s_1,2)),[size(B_s_1,2),1]);
theta_2 = reshape(x(size(B_s_1,2)+1:size(B_s_1,2)+size(B_s_2,2)),[size(B_s_2,2),1]);

error_1 = (data_trans{1}.x_outf - B_s_1*theta_1);                                % (N_1,1)
error_2 = (data_trans{2}.x_usda_lettuce - B_s_2*theta_2);         % (N_2,1)

fun = error_1'*B_IV_final_1*w_mat_1*B_IV_final_1'*error_1 +...
    error_2'*B_IV_final_2*w_mat_2*B_IV_final_2'*error_2;

if nargout>1
    
    grad = zeros(length(x),1);
    
    grad(1:length(theta_1)) = -2*B_s_1'*B_IV_final_1*w_mat_1*B_IV_final_1'*error_1;
    grad(length(theta_1)+1:length(theta_1)+length(theta_2)) = -2*B_s_2'*B_IV_final_2*w_mat_2*B_IV_final_2'*error_2;
    
end


end