function [ F ] = fun_foc(p,mc_1,mc_2,csi_1,csi_2,x_outf_norm,x_usda_norm,income_norm,p_out_norm,data_price,...
                         theta_BCS,option_prices)
% returns the J-dimensional FOC's to be set = 0, as a function of p

shares = share_fun_BCS(p(:,1),p(:,2),x_outf_norm,x_usda_norm,income_norm,p_out_norm,[csi_1 csi_2],theta_BCS);

if sum(shares)>0.999
    
    shares = shares-0.0005;
    
end

p_nonn = normalize_p_inv_fun([p(:,1),p(:,2)],data_price,option_prices);
df_dp = df_dp_fun([p(:,1),p(:,2)],data_price,option_prices);

deriv_own(1) = deriv_BCS_fun_own_p(p(:,1),p(:,2),x_outf_norm,x_usda_norm,income_norm,p_out_norm,[csi_1 csi_2],theta_BCS,1);
deriv_cross(1) = deriv_BCS_fun_cross_p(p(:,1),p(:,2),x_outf_norm,x_usda_norm,income_norm,p_out_norm,[csi_1 csi_2],theta_BCS,1);       % cross price elasticity of good 1 wrt p2

deriv_own(2) = deriv_BCS_fun_own_p(p(:,2),p(:,1),x_outf_norm,x_usda_norm,income_norm,p_out_norm,[csi_2 csi_1],theta_BCS,2);
deriv_cross(2) = deriv_BCS_fun_cross_p(p(:,2),p(:,1),x_outf_norm,x_usda_norm,income_norm,p_out_norm,[csi_2 csi_1],theta_BCS,2);       % cross price elasticity of good 2 wrt p1

J_sigma_p_tilde = [deriv_own(1)    deriv_cross(1);
                   deriv_cross(2)  deriv_own(2)];

J_norm_p = [df_dp(1) 0;
             0       df_dp(2)];

J_sigma_p = J_sigma_p_tilde*J_norm_p;

F(1) = shares(1) + (p_nonn(1)-mc_1)*J_sigma_p(1,1) + (p_nonn(2)-mc_2)*J_sigma_p(2,1);

F(2) = shares(2) + (p_nonn(2)-mc_2)*J_sigma_p(2,2) + (p_nonn(1)-mc_1)*J_sigma_p(1,2);


end