function [ F ] = fun_foc(p,mc_1,mc_2,delta_1,delta_2,income,p_out,data_price,...
                         theta_sigma,combos_all,m_regr,ngrid_invert_sigma,option_s,option_prices,q0)
% returns the J-dimensional FOC's to be set = 0, as a function of p

shares = fun_sigma_est(p(:,1),p(:,2),delta_1,delta_2,income,p_out,theta_sigma,combos_all,m_regr,ngrid_invert_sigma);

if sum(shares)>0.999
    
    shares = shares-0.0005;
    
end

quantities = q0*shares./(1-repmat(sum(shares),[size(shares)]));

jacobian_q_p = jacobian_q_p_fun(p,shares,quantities,theta_sigma,income,p_out,data_price,combos_all,m_regr,option_prices,option_s,q0);

p_nonn = normalize_p_inv_fun(p,data_price,option_prices);

F(1) = quantities(1) + (p_nonn(1)-mc_1)*jacobian_q_p(1,1) + (p_nonn(2)-mc_2)*jacobian_q_p(2,1);

F(2) = quantities(2) + (p_nonn(2)-mc_2)*jacobian_q_p(2,2) + (p_nonn(1)-mc_1)*jacobian_q_p(1,2);


end