function [f,grad] = gmmobj_fixedtol(theta,data_trans_both,mat_nohet,mat_het,s_vec,...
                    IV,T_new,J,K,H,wmat,csi_logit,theta_logit)
% This function computes the GMM objective function

%% get csi vector

[csi,s1,s2] = csi_fixedtol(theta,data_trans_both,s_vec,T_new,J,csi_logit,theta_logit);

% the following deals with cases where the min algorithm drifts into region where the objective is not defined
if max(isnan(csi)) == 1
    
    f = 1e+10;
    clear temp1
    
    grad = gradobj_2(csi,wmat,IV,s1,s2,mat_nohet,mat_het,theta,T_new,J,K,H);
       
       
else
        
    temp1 = csi'*IV;
    f = temp1*wmat*temp1';
    clear temp1
    
    grad = gradobj_2(csi,wmat,IV,s1,s2,mat_nohet,mat_het,theta,T_new,J,K,H);
    
    %     save('gmmresid.mat','gmmresid')
end

disp(['GMM objective:  ' num2str(f)])

end


