function jac = jacob_2(s1,s2,mat_nohet,mat_het,theta,T,J,K,H)
% This function computes the Jacobian of the implicit function that defines the mean utility

weight = theta(9);

s = [s1 s2];        %  first column: type 1; second column: type 2
ww = [weight 1-weight];

ntype = 2;

%% dsigma/dtheta

% (partial share)/(partial coeff) for coeffs on variables with no r.c.

ds_dcoeff_nohet = zeros(T*J,H);

for i = 1:H
    
    temp_final = zeros(T*J,ntype);
    
    for type=1:2
        
        temp = s(:,type).*mat_nohet(:,i);
        temp_r = reshape(temp,[T,J]);
        temp_final(:,type) = temp - s(:,type).*sum(repmat(temp_r,[J,1]),2);
                        
    end
    
    ds_dcoeff_nohet(:,i) = temp_final*ww';
    
end

% (partial share)/(partial coeff) for coeffs on variables with r.c.

ds_dcoeff_het = zeros(T*J,2*K);

for i = 1:K
    
    for type=1:2
        
        temp = s(:,type).*mat_het(:,i);
        temp_r = reshape(temp,[T,J]);
        temp_final = temp - s(:,type).*sum(repmat(temp_r,[J,1]),2);
                
        ds_dcoeff_het(:,(i-1)*ntype + type) = ww(type)*temp_final;
        
    end
    
end

% (partial share)/(partial coeff) for weights on types

ds_dweight = s1 - s2;

%%%%%%%%%%%%%%%%%%%%%%
% combine
% NB: order matters here

ds_dtheta = [ds_dcoeff_nohet    ds_dcoeff_het    ds_dweight];

% %% dsigma/dcsi
% 
% temp = s.*(1-s);
% 
% ds_dcsi = temp*g';

%% dcsi/dtheta

jac = zeros(T*J,H+2*K+1);

% THIS ONLY WORKS FOR J=2!!!!!!!!!!!!!!!!!!!!!!

for t=1:T
    
     ds1_dcsi1 = weight*s1(t)*(1-s1(t)) + (1-weight)*s2(t)*(1-s2(t));
     ds2_dcsi2 = weight*s1(T+t)*(1-s1(T+t)) + (1-weight)*s2(T+t)*(1-s2(T+t));
     ds1_dcsi2 = -(weight*s1(t)*s1(T+t) + (1-weight)*s2(t)*s2(T+t));            % equal to the other cross derivative
     ds2_dcsi1 = ds1_dcsi2;
     
     ds_dcsi = [ds1_dcsi1   ds1_dcsi2;
                ds2_dcsi1   ds2_dcsi2];
              
     ds_dtheta_select = ds_dtheta([t T+t],:);
     
     jac([t T+t],:) = -inv(ds_dcsi)*ds_dtheta_select;
    
end

end
