function [ mc_vec ] = mc_fun_BCS(price1,price2,prices_original,share1,share2,x_outf,x_usda,income,price_out,...
                                csi_vec,data,option_prices,theta_BCS)

df_dp1 = df_dp_fun(prices_original(1),data.p_own,option_prices);
df_dp2 = df_dp_fun(prices_original(2),data.p_own,option_prices);

der_own_est_temp = zeros(1,2);
der_cross_est_temp = zeros(1,2);

der_own_est_temp(1) = deriv_BCS_fun_own_p(price1,price2,x_outf,x_usda,income,price_out,csi_vec,theta_BCS,1);
der_cross_est_temp(1) = deriv_BCS_fun_cross_p(price1,price2,x_outf,x_usda,income,price_out,csi_vec,theta_BCS,1);       % cross price elasticity of good 1 wrt p2

der_own_est_temp(2) = deriv_BCS_fun_own_p(price2,price1,x_outf,x_usda,income,price_out,csi_vec([2 1]),theta_BCS,2);
der_cross_est_temp(2) = deriv_BCS_fun_cross_p(price2,price1,x_outf,x_usda,income,price_out,csi_vec([2 1]),theta_BCS,2);       % cross price elasticity of good 2 wrt p1

J_sigma_p_tilde = [der_own_est_temp(1)     der_cross_est_temp(1);
    der_cross_est_temp(2)    der_own_est_temp(2)];

J_norm_p = [df_dp1 0;
    0     df_dp2];

J_sigma_p = J_sigma_p_tilde*J_norm_p;

mc_vec = prices_original + inv(J_sigma_p')*[share1 share2]';

end

