function [ mc_vec ] = mc_fun_normaliz_NPD(theta_sigma,p_norm,p_nonn,shares,income,p_out,m_regr,combos_all,data,option_prices)

% gives the NON-NORMALIZED mc (i.e. to be compared with NON-NORMALIZED prices)

df_dp1 = df_dp_fun(p_nonn(1),data.p_own,option_prices);
df_dp2 = df_dp_fun(p_nonn(2),data.p_own,option_prices);

J_sigmainv_s = jacobian_sigma_inv_s(theta_sigma,[shares(1) shares(2)],[p_norm(1) p_norm(2)],income,p_out,m_regr,combos_all);
J_sigmainv_p = jacobian_sigma_inv_p(theta_sigma,[shares(1) shares(2)],[p_norm(1) p_norm(2)],income,p_out,m_regr,combos_all);
J_norm_p = [df_dp1 0;
    0     df_dp2];

J_sigma_p = -inv(J_sigmainv_s)*J_sigmainv_p*J_norm_p;

mc_vec = p_nonn' + inv(J_sigma_p')*[shares(1) shares(2)]';

end