function [ c,ceq,gradc,gradceq ] = nonlcon_fun(theta_BCS,data,data_trans,option_prices)

combos_x = allcomb(quantile(data_trans{1}.x_outf,[0.125  0.875]),quantile(data_trans{1}.x_usda_lettuce,[0.125  0.875]));

combos_p = allcomb(quantile(data_trans{1}.p_own,[0.125  0.875]),quantile(data_trans{2}.p_own,[0.125  0.875]));
        
grid_quant_income = linspace(0.01,0.99,3);
combos_income = quantile(data_trans{1}.income,grid_quant_income)';

grid_quant_p_out = linspace(0.01,0.99,3);
combos_p_out = quantile(data_trans{1}.p_out_avg,grid_quant_p_out)';

c = [];
gradc = [];

for xx=1:size(combos_x,1)
    for pp=1:size(combos_p,1)
        for ii=1:size(combos_income,1)
            for poutt=1:size(combos_p_out,1)
                
                
                prices_original = normalize_p_inv_fun(combos_p(pp,:),data.p_own,option_prices);        % 2-vector
                
                price1 = combos_p(pp,1);
                df_dp1 = df_dp_fun(prices_original(1),data.p_own,option_prices);
                
                price2 = combos_p(pp,2);
                df_dp2 = df_dp_fun(prices_original(2),data.p_own,option_prices);
                
                x_outf = combos_x(xx,1);
                x_usda = combos_x(xx,2);
                csi_vec = [0 0];
                
                income = combos_income(ii);
                price_out = combos_p_out(poutt);
                
                shares = share_fun_BCS(price1,price2,x_outf,x_usda,income,price_out,csi_vec,theta_BCS);
                
                deriv_own_est_temp = zeros(1,2);
                deriv_cross_est_temp = zeros(1,2);
                
                deriv_own_est_temp(1) = deriv_BCS_fun_own_p(price1,price2,x_outf,x_usda,income,price_out,csi_vec,theta_BCS,1);
                deriv_cross_est_temp(1) = deriv_BCS_fun_cross_p(price1,price2,x_outf,x_usda,income,price_out,csi_vec,theta_BCS,1);       % cross price elasticity of good 1 wrt p2
                
                deriv_own_est_temp(2) = deriv_BCS_fun_own_p(price2,price1,x_outf,x_usda,income,price_out,csi_vec([2 1]),theta_BCS,2);
                deriv_cross_est_temp(2) = deriv_BCS_fun_cross_p(price2,price1,x_outf,x_usda,income,price_out,csi_vec([2 1]),theta_BCS,2);       % cross price elasticity of good 2 wrt p1
                
                J_sigma_p_tilde = [deriv_own_est_temp(1)      deriv_cross_est_temp(1);
                    deriv_cross_est_temp(2)    deriv_own_est_temp(2)];
                
                J_norm_p = [df_dp1 0;
                    0     df_dp2];
                
                J_sigma_p = J_sigma_p_tilde*J_norm_p;
                
                mc_vec = prices_original' + inv(J_sigma_p')*shares';
                
                c = [c;
                    -mc_vec];
                
                % grad
                
                grad_J_sigma_p_tilde_inv = grad_J_sigma_p_tilde_inv_fun(price1,price2,x_outf,x_usda,income,price_out,csi_vec,theta_BCS);
                
                mat1 = eye(2);
                mat2 = inv(J_norm_p');
                
                grad_shares = zeros(length(theta_BCS),2);
                grad_shares(:,1) = grad_theta_analy_shares(price1,price2,x_outf,x_usda,income,price_out,csi_vec,theta_BCS,1);
                grad_shares(:,2) = grad_theta_analy_shares(price2,price1,x_outf,x_usda,income,price_out,csi_vec([2 1]),theta_BCS,2);
                
                grad_mat = zeros(2,2,length(theta_BCS));
                mc_grad_temp = zeros(2,length(theta_BCS));
                
                for k=1:length(theta_BCS)
                    temp_mat = grad_J_sigma_p_tilde_inv(:,:,k)';
                    grad_mat(:,:,k) = mat1*temp_mat*mat2;
                    mc_grad_temp(:,k) = grad_mat(:,:,k)*shares' + inv(J_sigma_p')*grad_shares(k,:)';
                end
                
                gradc = [gradc   -mc_grad_temp(1,:)'   -mc_grad_temp(2,:)'];
                
            end
            
        end
        
    end
end


ceq = [];
gradceq = [];



end