function [ shares ] = share_fun_BCS(p_own,p_other,x_outf,x_usda,income,p_out,csi_demeaned,theta_BCS)

% NB: order of inputs AND outputs is (good1, good2)

constant = theta_BCS(1:2);
coeff_p_income = theta_BCS(3);
coeff_p_out = theta_BCS(4);
coeff_x_outf = theta_BCS(5);
coeff_x_usda = theta_BCS(6);
coeff_p = theta_BCS(7:8);
weight = theta_BCS(9);

p_own = reshape(p_own,[numel(p_own) 1]);
lp = length(p_own);

csi_own = csi_demeaned(1);
csi_other = csi_demeaned(2);

util_own_1 = constant(1) + coeff_p(1)*p_own + coeff_x_outf*x_outf + coeff_p_income*p_own.*income + coeff_p_out*p_out + csi_own;
util_own_2 = constant(1) + coeff_p(2)*p_own + coeff_x_outf*x_outf + coeff_p_income*p_own.*income + coeff_p_out*p_out + csi_own;

util_other_1 = constant(2) + coeff_p(1)*p_other + coeff_x_outf*x_outf + coeff_x_usda*x_usda + coeff_p_income*p_other.*income + coeff_p_out*p_out + csi_other;
util_other_2 = constant(2) + coeff_p(2)*p_other + coeff_x_outf*x_outf + coeff_x_usda*x_usda + coeff_p_income*p_other.*income + coeff_p_out*p_out + csi_other;

temp_own_1 = exp(util_own_1);
temp_own_2 = exp(util_own_2);

temp_other_1 = exp(util_other_1);
temp_other_2 = exp(util_other_2);

share_own_1 = temp_own_1./(1+temp_own_1+temp_other_1);
share_own_2 = temp_own_2./(1+temp_own_2+temp_other_2);
share_own_final = share_own_1*weight + share_own_2*(1-weight);

share_other_1 = temp_other_1./(1+temp_own_1+temp_other_1);
share_other_2 = temp_other_2./(1+temp_own_2+temp_other_2);
share_other_final = share_other_1*weight + share_other_2*(1-weight);

shares = [share_own_final share_other_final];

end