function [ A_diag_dom_p ] = A_diag_dom_p_fun_2(m_regr,combos_s1_s2,combos_p1_p2,temp_mat)
% Imposes 'vertical' diagonal dominance (one by one) on the jacobian of sigma inverse
% wrt p

J = 2;

A_diag_dom_p = [];

for s=1:size(combos_s1_s2,1)          % loop over combos of shares
    for p=1:size(combos_p1_p2,1)          % loop over combos of prices
        
        combos_s = combos_s1_s2(s,:);
        combos_p = combos_p1_p2(p,:);
        
        combos_s_c = num2cell(combos_s1_s2(s,:));
        combos_p_c = num2cell(combos_p1_p2(p,:));
        
        for j = 2:J            % other good wrt whose derivative we compare the derivative wrt own good
            
            indices = [j setdiff(1:J,j)];
            [~,position]=sort(indices);     % position(r) gives the position of the r-th good in the indices vector
            
            combos_s_reord = combos_s(indices);
            combos_p_reord = combos_p(indices);
            
            combos_s_reord_c = num2cell(combos_s_reord);
            combos_p_reord_c = num2cell(combos_p_reord);
            
            %%
            
            if combos_p(1)<m_regr(3)+1
                
                temp = temp_mat;
                
                temp_ind = combos_p;
                vec = zeros(size(temp_ind));
                vec(1) = +1;
                temp_ind2 = temp_ind + vec;
                temp_ind2_c = num2cell(temp_ind2);
                
                temp(combos_s_c{:},temp_ind2_c{:}) = temp(combos_s_c{:},temp_ind2_c{:}) - 1;        % minus derivative of first good wrt own price
                temp(combos_s_c{:},combos_p_c{:}) = temp(combos_s_c{:},combos_p_c{:}) + 1;
                
                temp_ind = combos_p_reord;
                vec = zeros(size(temp_ind));
                vec(position(1)) = +1;
                temp_ind2 = temp_ind + vec;
                temp_ind2_c = num2cell(temp_ind2);
                
                temp(combos_s_reord_c{:},temp_ind2_c{:}) = temp(combos_s_reord_c{:},temp_ind2_c{:}) + 1;        % derivative of j-th good wrt 1st good's price
                temp(combos_s_reord_c{:},combos_p_reord_c{:}) = temp(combos_s_reord_c{:},combos_p_reord_c{:}) - 1;
                
                A_diag_dom_p = [A_diag_dom_p;
                    reshape(temp,1,numel(temp))];
                
            end
            
            %%
            
            if combos_p(1)>1
                
                temp = temp_mat;
                
                temp_ind = combos_p;
                vec = zeros(size(temp_ind));
                vec(1) = -1;
                temp_ind2 = temp_ind + vec;
                temp_ind2_c = num2cell(temp_ind2);
                
                temp(combos_s_c{:},temp_ind2_c{:}) = temp(combos_s_c{:},temp_ind2_c{:}) + 1;        % minus the derivative of first good wrt own price
                temp(combos_s_c{:},combos_p_c{:}) = temp(combos_s_c{:},combos_p_c{:}) - 1;
                
                temp_ind = combos_p_reord;
                vec = zeros(size(temp_ind));
                vec(position(1)) = -1;
                temp_ind2 = temp_ind + vec;
                temp_ind2_c = num2cell(temp_ind2);
                
                temp(combos_s_reord_c{:},temp_ind2_c{:}) = temp(combos_s_reord_c{:},temp_ind2_c{:}) - 1;        % derivative of j-th good wrt 1st good's price
                temp(combos_s_reord_c{:},combos_p_reord_c{:}) = temp(combos_s_reord_c{:},combos_p_reord_c{:}) + 1;
                
                A_diag_dom_p = [A_diag_dom_p;
                    reshape(temp,1,numel(temp))];
                
            end
            
        end
    end
end
                
A_diag_dom_p = unique(A_diag_dom_p,'rows');
A_diag_dom_p = setdiff(A_diag_dom_p,zeros(1,size(A_diag_dom_p,2)),'rows');

end

