function [ A_diag_dom_p ] = A_diag_dom_p_noexch_fun_3(m_regr,combos_s1_s2,combos_p1_p2,temp_mat2)
% Imposes 'vertical' diagonal dominance (one by one) on the jacobian of sigma inverse
% wrt p

J = 2;

A_diag_dom_p = [];

%% derivative wrt p1

k = 1;                        % this is the good wrt whose price we take derivatives (it's a vertical comparison, recall)

for s=1:size(combos_s1_s2,1)          % loop over combos of shares
    for p=1:size(combos_p1_p2,1)          % loop over combos of prices
        
        combos_s = combos_s1_s2(s,:);
        combos_p = combos_p1_p2(p,:);
        
        combos_s_c = num2cell(combos_s1_s2(s,:));
        combos_p_c = num2cell(combos_p1_p2(p,:));
        
        j = 2;           % other good wrt whose derivative we compare the derivative wrt own good
        
%         indices = [j setdiff(1:J,j)];
%         [~,position]=sort(indices);     % position(r) gives the position of the r-th good in the indices vector
        
        combos_s_reord = combos_s([2 1]);
        combos_p_reord = combos_p([2 1]);
        
        combos_s_reord_c = num2cell(combos_s_reord);
        combos_p_reord_c = num2cell(combos_p_reord);
        
        %%
        
        if combos_p(1)<m_regr(J+1)+1
            
            temp = temp_mat2;
            
            temp_ind = combos_p;
            vec = zeros(size(temp_ind));
            vec(1) = +1;                    % 1 because this is the derivative wrt own price
            temp_ind2 = temp_ind + vec;
            temp_ind2_c = num2cell(temp_ind2);
            
            temp(combos_s_c{:},temp_ind2_c{:},k) = temp(combos_s_c{:},temp_ind2_c{:},k) - 1;        % minus derivative of k-th good wrt own price
            temp(combos_s_c{:},combos_p_c{:},k) = temp(combos_s_c{:},combos_p_c{:},k) + 1;
            
            temp_ind = combos_p_reord;
            vec = zeros(size(temp_ind));
            vec(2) = +1;                    % 2 because this is the derivative wrt other price
            temp_ind2 = temp_ind + vec;
            temp_ind2_c = num2cell(temp_ind2);
            
            temp(combos_s_reord_c{:},temp_ind2_c{:},j) = temp(combos_s_reord_c{:},temp_ind2_c{:},j) + 1;        % derivative of j-th good wrt k-th good's price
            temp(combos_s_reord_c{:},combos_p_reord_c{:},j) = temp(combos_s_reord_c{:},combos_p_reord_c{:},j) - 1;
            
            A_diag_dom_p = [A_diag_dom_p;
                reshape(temp,1,numel(temp))];
            
        end
        
        %%
        
        if combos_p(1)>1
            
            temp = temp_mat2;
            
            temp_ind = combos_p;
            vec = zeros(size(temp_ind));
            vec(1) = -1;
            temp_ind2 = temp_ind + vec;
            temp_ind2_c = num2cell(temp_ind2);
            
            temp(combos_s_c{:},temp_ind2_c{:},k) = temp(combos_s_c{:},temp_ind2_c{:},k) + 1;        % minus the derivative of k-th good wrt own price
            temp(combos_s_c{:},combos_p_c{:},k) = temp(combos_s_c{:},combos_p_c{:},k) - 1;
            
            temp_ind = combos_p_reord;
            vec = zeros(size(temp_ind));
            vec(2) = -1;
            temp_ind2 = temp_ind + vec;
            temp_ind2_c = num2cell(temp_ind2);
            
            temp(combos_s_reord_c{:},temp_ind2_c{:},j) = temp(combos_s_reord_c{:},temp_ind2_c{:},j) - 1;        % derivative of j-th good wrt k-th good's price
            temp(combos_s_reord_c{:},combos_p_reord_c{:},j) = temp(combos_s_reord_c{:},combos_p_reord_c{:},j) + 1;
            
            A_diag_dom_p = [A_diag_dom_p;
                reshape(temp,1,numel(temp))];
            
        end
    end
end

%% derivative wrt p2

k = 2;                        % this is the good wrt whose price we take derivatives (it's a vertical comparison, recall)

for s=1:size(combos_s1_s2,1)          % loop over combos of shares
    for p=1:size(combos_p1_p2,1)          % loop over combos of prices
        
        combos_s = combos_s1_s2(s,:);
        combos_p = combos_p1_p2(p,:);
        
        combos_s_c = num2cell(combos_s1_s2(s,:));
        combos_p_c = num2cell(combos_p1_p2(p,:));
        
        j = 1;           % other good wrt whose derivative we compare the derivative wrt own good
        
%         indices = [j setdiff(1:J,j)];
%         [~,position]=sort(indices);     % position(r) gives the position of the r-th good in the indices vector
        
        combos_s_reord = combos_s([2 1]);
        combos_p_reord = combos_p([2 1]);
        
        combos_s_reord_c = num2cell(combos_s_reord);
        combos_p_reord_c = num2cell(combos_p_reord);
        
        %%
        
        if combos_p(1)<m_regr(J+1)+1
            
            temp = temp_mat2;
            
            temp_ind = combos_p;
            vec = zeros(size(temp_ind));
            vec(1) = +1;                    % 1 because this is the derivative wrt own price
            temp_ind2 = temp_ind + vec;
            temp_ind2_c = num2cell(temp_ind2);
            
            temp(combos_s_c{:},temp_ind2_c{:},k) = temp(combos_s_c{:},temp_ind2_c{:},k) - 1;        % minus derivative of k-th good wrt own price
            temp(combos_s_c{:},combos_p_c{:},k) = temp(combos_s_c{:},combos_p_c{:},k) + 1;
            
            temp_ind = combos_p_reord;
            vec = zeros(size(temp_ind));
            vec(2) = +1;                    % 2 because this is the derivative wrt other price
            temp_ind2 = temp_ind + vec;
            temp_ind2_c = num2cell(temp_ind2);
            
            temp(combos_s_reord_c{:},temp_ind2_c{:},j) = temp(combos_s_reord_c{:},temp_ind2_c{:},j) + 1;        % derivative of j-th good wrt k-th good's price
            temp(combos_s_reord_c{:},combos_p_reord_c{:},j) = temp(combos_s_reord_c{:},combos_p_reord_c{:},j) - 1;
            
            A_diag_dom_p = [A_diag_dom_p;
                reshape(temp,1,numel(temp))];
            
        end
        
        %%
        
        if combos_p(1)>1
            
            temp = temp_mat2;
            
            temp_ind = combos_p;
            vec = zeros(size(temp_ind));
            vec(1) = -1;
            temp_ind2 = temp_ind + vec;
            temp_ind2_c = num2cell(temp_ind2);
            
            temp(combos_s_c{:},temp_ind2_c{:},k) = temp(combos_s_c{:},temp_ind2_c{:},k) + 1;        % minus the derivative of k-th good wrt own price
            temp(combos_s_c{:},combos_p_c{:},k) = temp(combos_s_c{:},combos_p_c{:},k) - 1;
            
            temp_ind = combos_p_reord;
            vec = zeros(size(temp_ind));
            vec(2) = -1;
            temp_ind2 = temp_ind + vec;
            temp_ind2_c = num2cell(temp_ind2);
            
            temp(combos_s_reord_c{:},temp_ind2_c{:},j) = temp(combos_s_reord_c{:},temp_ind2_c{:},j) - 1;        % derivative of j-th good wrt k-th good's price
            temp(combos_s_reord_c{:},combos_p_reord_c{:},j) = temp(combos_s_reord_c{:},combos_p_reord_c{:},j) + 1;
            
            A_diag_dom_p = [A_diag_dom_p;
                reshape(temp,1,numel(temp))];
            
        end
    end
end

A_diag_dom_p = unique(A_diag_dom_p,'rows');
A_diag_dom_p = setdiff(A_diag_dom_p,zeros(1,size(A_diag_dom_p,2)),'rows');

end

