function [ A_symmetry ] = A_symmetry_fun_2(m_regr,combos_all_unique)

%% Impose symmetry wrt s (i.e. delta) for any given vector of prices

J = 2;

n_Bcoeff = size(combos_all_unique,1);

A_symmetry = [];

parfor k=1:n_Bcoeff           % combos for s and p
    for j=2:J                 % good wrt which we take the increment
        
        ind_reorder = [j setdiff(1:J,j)];
        [~,position] = sort(ind_reorder);     % position(r) gives the position of the r-th good in the indices vector
        
        combos_s = double(combos_all_unique(k,1:J));
        combos_p = double(combos_all_unique(k,J+1:end));
        temp_ind = double(combos_all_unique(k,:));
        
        combos_s_reord = combos_s(ind_reorder);
        combos_p_reord = combos_p(ind_reorder);
        temp_ind_reord = rep2unique([combos_s_reord combos_p_reord],J);
        
        %%
        
        if combos_s(j)<m_regr(j)+1 && combos_s(1)<m_regr(1)+1
            
            temp = zeros(1,n_Bcoeff);
            
            % derivative of own inverse sigma wrt s_j
            
            combos_s_plus1 = combos_s + [zeros(1,j-1) 1 zeros(1,J-j)];
            temp_ind2 = rep2unique([combos_s_plus1 combos_p],J);
            
            temp(ismember(combos_all_unique,temp_ind,'rows')) = temp(ismember(combos_all_unique,temp_ind,'rows')) - 1;
            temp(ismember(combos_all_unique,temp_ind2,'rows')) = temp(ismember(combos_all_unique,temp_ind2,'rows')) + 1;
            
            % derivative of j inverse sigma wrt own
            
            vec = zeros(1,J);
            vec(position(1)) = 1;
            combos_s_plus1 = combos_s_reord + vec;
            temp_ind2 = rep2unique([combos_s_plus1 combos_p_reord],J);
            
            temp(ismember(combos_all_unique,temp_ind_reord,'rows')) = temp(ismember(combos_all_unique,temp_ind_reord,'rows')) + 1;
            temp(ismember(combos_all_unique,temp_ind2,'rows')) = temp(ismember(combos_all_unique,temp_ind2,'rows')) - 1;
            
            A_symmetry = [A_symmetry;
                reshape(temp,1,numel(temp))];
            
        end
        
        %%
        
        if combos_s(j)>1 && combos_s(1)>1
            
            temp = zeros(1,n_Bcoeff);
            
            % derivative of own inverse sigma wrt s_j
            
            combos_s_minus1 = combos_s + [zeros(1,j-1) -1 zeros(1,J-j)];
            temp_ind2 = rep2unique([combos_s_minus1 combos_p],J);
            
            temp(ismember(combos_all_unique,temp_ind,'rows')) = temp(ismember(combos_all_unique,temp_ind,'rows')) + 1;
            temp(ismember(combos_all_unique,temp_ind2,'rows')) = temp(ismember(combos_all_unique,temp_ind2,'rows')) - 1;
            
            % derivative of j inverse sigma wrt own
            
            vec = zeros(1,J);
            vec(position(1)) = 1;
            combos_s_minus1 = combos_s_reord - vec;
            temp_ind2 = rep2unique([combos_s_minus1 combos_p_reord],J);
            
            temp(ismember(combos_all_unique,temp_ind_reord,'rows')) = temp(ismember(combos_all_unique,temp_ind_reord,'rows')) - 1;
            temp(ismember(combos_all_unique,temp_ind2,'rows')) = temp(ismember(combos_all_unique,temp_ind2,'rows')) + 1;
            
            A_symmetry = [A_symmetry;
                reshape(temp,1,numel(temp))];
            
        end
        
        %%
        
        if combos_s(j)>1 && combos_s(1)<m_regr(1)+1
            
            temp = zeros(1,n_Bcoeff);
            
            % derivative of own inverse sigma wrt s_j
            
            combos_s_minus1 = combos_s + [zeros(1,j-1) -1 zeros(1,J-j)];
            temp_ind2 = rep2unique([combos_s_minus1 combos_p],J);
            
            temp(ismember(combos_all_unique,temp_ind,'rows')) = temp(ismember(combos_all_unique,temp_ind,'rows')) + 1;
            temp(ismember(combos_all_unique,temp_ind2,'rows')) = temp(ismember(combos_all_unique,temp_ind2,'rows')) - 1;
            
            % derivative of j inverse sigma wrt own
            
            vec = zeros(1,J);
            vec(position(1)) = 1;
            combos_s_plus1 = combos_s_reord + vec;
            temp_ind2 = rep2unique([combos_s_plus1 combos_p_reord],J);
            
            temp(ismember(combos_all_unique,temp_ind_reord,'rows')) = temp(ismember(combos_all_unique,temp_ind_reord,'rows')) + 1;
            temp(ismember(combos_all_unique,temp_ind2,'rows')) = temp(ismember(combos_all_unique,temp_ind2,'rows')) - 1;
            
            A_symmetry = [A_symmetry;
                reshape(temp,1,numel(temp))];
            
        end
        
        %%
        
        if combos_s(j)<m_regr(j)+1 && combos_s(1)>1
            
            temp = zeros(1,n_Bcoeff);
            
            % derivative of own inverse sigma wrt s_j
            
            combos_s_plus1 = combos_s + [zeros(1,j-1) 1 zeros(1,J-j)];
            temp_ind2 = rep2unique([combos_s_plus1 combos_p],J);
            
            temp(ismember(combos_all_unique,temp_ind,'rows')) = temp(ismember(combos_all_unique,temp_ind,'rows')) - 1;
            temp(ismember(combos_all_unique,temp_ind2,'rows')) = temp(ismember(combos_all_unique,temp_ind2,'rows')) + 1;
            
            % derivative of j inverse sigma wrt own
            
            vec = zeros(1,J);
            vec(position(1)) = 1;
            combos_s_minus1 = combos_s_reord - vec;
            temp_ind2 = rep2unique([combos_s_minus1 combos_p_reord],J);
            
            temp(ismember(combos_all_unique,temp_ind_reord,'rows')) = temp(ismember(combos_all_unique,temp_ind_reord,'rows')) - 1;
            temp(ismember(combos_all_unique,temp_ind2,'rows')) = temp(ismember(combos_all_unique,temp_ind2,'rows')) + 1;
            
            A_symmetry = [A_symmetry;
                reshape(temp,1,numel(temp))];
             
        end
    end
    %k
end

A_symmetry = unique(A_symmetry,'rows');
A_symmetry = setdiff(A_symmetry,zeros(1,size(A_symmetry,2)),'rows');

end