function bvm = BernsteinElement(vv,m,argument_norm)

% argument_norm must be a COLUMN vector

% ouput is of size (size(vv,1),size(argument_norm,2),J)
    
    Nv = size(vv,1);
    argument_norm  = permute(repmat(argument_norm,[1 1 Nv]),[3 2 1]);                % argument_norm is of size (Nv,length(u),J)

    vv2 = permute(repmat(vv,[1 1 size(argument_norm,2)]),[1 3 2]);      % (Nv,length(u),J)
    mm  = m*ones(size(vv2));                                            % (Nv,length(u),J)

    NZ = (vv2 <= mm & vv2 >= 0); % Bernstein pol. is zero otherwise.    % (Nv,length(u),J)

    bvm = zeros(size(argument_norm)); % Allocate space for pol.

    vv3 = vv2(NZ); mm2 = mm(NZ); argument_norm2 = argument_norm(NZ);
    Bin = factorial(mm2)./factorial(mm2-vv3)./factorial(vv3);
    bvm(NZ) = Bin.*(argument_norm2.^vv3).*((1-argument_norm2).^(mm2-vv3));
    
end