function [combos_s2,combos_p2,combos_s1_s2,combos_p1_p2,combos_all,combos_IV,nonlin_s,nonlin_p] = combinations_2(m_regr,m_IV,ngrid_s_nonl,ngrid_p_nonl,data_trans,nIV)

%% combos1 and combos2

combos_s1 = (1:m_regr(1)+1)';
combos_s2 = (1:m_regr(2)+1)';

combos_p1 = (1:m_regr(3)+1)';
combos_p2 = (1:m_regr(4)+1)';

combos_s1_s2 = allcomb(1:m_regr(1)+1,1:m_regr(2)+1);
combos_s1_s2 = combos_s1_s2(:,[2 1]);

combos_p1_p2 = allcomb(1:m_regr(3)+1,1:m_regr(4)+1);
combos_p1_p2 = combos_p1_p2(:,[2 1]);

% NB: order of columns in terms of which one moves faster is different than
% in the baseline folder, but the resulting constraint matrix is the same

%% combos_all

temp = cell(4,1);
for i=1:4
    
    temp{i} = 1:m_regr(4-i+1)+1;
    
end
combos_all = allcomb(temp{:});     
combos_all = combos_all(:,[4 3 2 1]);       % key is that the index that moves "faster" is in the first column, then second one, and so on
                                            % (has to be consistent with order of theta, vs combos_IV where it does not matter)
                                            
%% combos_IV

temp_cell = cell(nIV,1);
for j=1:nIV
    
    temp_cell{j} = (1:m_IV+1);
    
end
combos_IV = (sortrows(allcomb(temp_cell{:})));

%% combos_s and combos_p

grid_quant_s1 = linspace(0.01,0.99,ngrid_s_nonl(1));
grid_quant_s2 = linspace(0.01,0.99,ngrid_s_nonl(2));
grid_s1 = quantile(data_trans{1}.s_own,grid_quant_s1);
grid_s2 = quantile(data_trans{2}.s_own,grid_quant_s2);
nonlin_s = allcomb(grid_s1,grid_s2);
nonlin_s(sum(nonlin_s,2)>1,:) = [];

grid_quant_p1 = linspace(0.01,0.99,ngrid_p_nonl(1));
grid_quant_p2 = linspace(0.01,0.99,ngrid_p_nonl(2));
grid_p1 = quantile(data_trans{1}.p_own,grid_quant_p1);
grid_p2 = quantile(data_trans{2}.p_own,grid_quant_p2);
nonlin_p = allcomb(grid_p1,grid_p2);


end