function [ elasticity_cross ] = elasticity_BLP_fun_cross_p(p_own,p_other,x,csi_demeaned,normal_draw,theta_BLP)

% NB: normal_draw are the draws from bivariate N(0,1) used to generate
% rc_draw
% NB: gives the cross elasticity of good 1 wrt price of good 2

constant_est = theta_BLP(1);
alpha_mu_est = theta_BLP(2);
beta_mu_est = theta_BLP(3);
alpha_sigma_est = theta_BLP(4);
beta_sigma_est = theta_BLP(5);

rc_draw(1,:) = normal_draw(1,:)*alpha_sigma_est + alpha_mu_est;
rc_draw(2,:) = normal_draw(2,:)*beta_sigma_est + beta_mu_est;

p_own = reshape(p_own,[numel(p_own) 1]);
lp = length(p_own);

x_own = x(1);
x_other = x(2);

csi = csi_demeaned+constant_est;
csi_own = csi(1);
csi_other = csi(2);

util_own = bsxfun(@plus,repmat(x_own,[lp,1])*rc_draw(2,:),p_own*rc_draw(1,:)) + csi_own;
util_other = bsxfun(@plus,repmat(x_other,[lp,1])*rc_draw(2,:),repmat(p_other,[lp,1])*rc_draw(1,:)) + csi_other;

temp_own = exp(util_own);
temp_other = exp(util_other);

share_own = temp_own./(1+temp_own+temp_other);
share_other = temp_other./(1+temp_own+temp_other);
deriv_own = -share_own.*share_other.*repmat(rc_draw(1,:),[lp,1]);

elasticity_cross = mean(deriv_own,2).*p_other./mean(share_own,2);

end