function [theta_NPD,p_coeff_NPD,fval_NPD,flag_NPD] = estimation_NPD_cvx_2_s(data_trans,J,T,m_regr,m_IV,A_ineq,A_eq,b_ineq,b_eq,...
                                                            combos_all_unique,combos_IV_small,option_symm,ntheta)

B_IV_final = cell(J,1);
B_s = cell(J,1);
w_mat = cell(J,1);

for j=1:J
   
    B_IV_final{j} = single(zeros(T,size(combos_IV_small,1)));
    B_s{j} = single(zeros(T,size(combos_all_unique,1)));
    w_mat{j} = single(zeros(size(combos_IV_small,1),size(combos_IV_small,1)));
    
end

for j=1:J
    
    B_IV_final{j} = B_IV_fun_2(data_trans{j},combos_IV_small,combos_all_unique,m_IV);
    
    B_s{j} = B_s_fun_s(data_trans{j},m_regr,combos_all_unique,T,J);        % (T,size(combos_all_unique,1)) array
    
    temp = B_IV_final{j}'*B_IV_final{j};
    
    if det(B_IV_final{j}*temp*B_IV_final{j}')==0
        
        w_mat{j} = inv(B_IV_final{j}'*B_IV_final{j} + 0.01*eye(size(temp)));
        
    else w_mat{j} = inv(B_IV_final{j}'*B_IV_final{j});
    end
    
end


%nonlcon = @(tt) nonlcon_fun(tt,m_regr,J,combos_s,combos_p,ntheta,combos_all_unique,combos_perms);

% hessian_fun = @(x,lambda_hess) hessianfcn(x,lambda_hess,B_s,B_IV_final,w_mat,combos_s,combos_p,J,m_regr,ntheta,ngamma,combos_all_unique,combos_perms);

fun_criterion = @(x) estimation_criterion_s(x,data_trans,w_mat,B_s,B_IV_final,J);

ub = 100;
lb = -100;

if strcmp(option_symm,'yes')
    
    cvx_begin %quiet
    
    cvx_precision default
    variable theta_temp(ntheta,1)
    variable p_coeff(1)
    
    x = (reshape(theta_temp,[numel(theta_temp),1]));
    
    minimize( fun_criterion([x;p_coeff]) )
    subject to
    A_ineq*x <= b_ineq
    A_eq*x == b_eq
    x<=ub
    x>=lb
    
    cvx_end
    
else    % i.e. if A_eq = []
    
    cvx_begin %quiet
    
    cvx_precision default
    variable theta_temp(ntheta,1)
    variable p_coeff(1)
    
    x = (reshape(theta_temp,[numel(theta_temp),1]));
    
    minimize( fun_criterion([x;p_coeff]) )
    subject to
    A_ineq*x <= b_ineq
    x<=ub
    x>=lb
    
    cvx_end
    
end

theta_NPD = theta_temp;
p_coeff_NPD = p_coeff;
fval_NPD = cvx_optval;
flag_NPD = cvx_status;

end