function [ fun,grad ] = estimation_criterion_s(x,data_trans,w_mat,B_s,B_IV_final,J)

theta = reshape(x(1:size(B_s{1},2)),[size(B_s{1},2),1]);
p_coeff = x(size(B_s{1},2)+1);

fun = 0;
grad = zeros(length(theta),1);

for j=1:J
    
    B_s_temp = double(B_s{j});
    B_IV_final_temp = double(B_IV_final{j});
    w_mat_temp = double(w_mat{j});
    
    error = (data_trans{j}.x_own + p_coeff*data_trans{j}.p_own - B_s_temp*theta);         % (N,1)
    
    fun_temp = error'*B_IV_final_temp*w_mat_temp*B_IV_final_temp'*error;
    
    if nargout>1
        
        grad_temp = -2*B_s_temp'*B_IV_final_temp*w_mat_temp*B_IV_final_temp'*error;
        grad = grad+grad_temp;
        
    end
    
    fun = fun+fun_temp;
        
end

% fun = (sum(fun_temp));
% 
% grad = (sum(grad_temp,2));

end