function [theta1_BLP,theta2_BLP,fval_BLP,flag_BLP,V_BLP] = fun_estimation_BLP_fixedtol_fmincon_J(data,ns,K,J,theta2_0,T_new,nx0)

v = randn(ns,K+1);

x1 = [ones(T_new*J,1) data.p(:) data.x(:)];     % T*J - by - H; first all observations for good 1, then good 2 and so on...
%x1 = [kron(eye(J),ones(T_new,1)) data.p(:) data.x(:)];     % T*J - by - H+J; first all observations for good 1, then good 2 and so on...
x2 = [data.p(:) data.x(:)];
s_vec = data.s(:);
IV = [repmat(data.z,[J,1]) repmat(data.z.^2,[J,1])...
    repmat(data.x,[J,1]) repmat(data.x.^2,[J,1])...
    repmat(prod(data.x,2),[J,1]) repmat(data.x.*data.z,[J,1]) kron(eye(J),ones(T_new,1))];
% IV = [repmat(data.z,[J,1]) repmat(data.z.^2,[J,1]) repmat(data.x,[J,1]) repmat(prod(data.x,2),[J,1])];
% IV = [repmat(data.z,[J,1]) repmat(data.z.^2,[J,1]) repmat(data.x,[J,1]) repmat(prod(data.x,2),[J,1]) repmat(sum((data.x).^2,2),[J,1])];
M = size(IV,2);      % M = number of IV
wmat = inv([IV'*IV]);

s0 = 1.0-sum(data.s,2);

y = log(s_vec) - repmat(log(s0),[J,1]);
mid = x1'*IV*wmat*IV';
t = inv(mid*x1)*mid*y;
mvalold = x1*t;
oldt2 = zeros(size(theta2_0));
mvalold = exp(mvalold);

%     save mvalold mvalold oldt2
%     clear mid y outshr t oldt2 mvalold temp sum1

options = optimoptions('fmincon',         ...
    'Algorithm',       'interior-point', ...
    'Display',         'iter-detailed', ...
    'DerivativeCheck', 'off', ...
    'Hessian',         'off', ...
    'GradObj',         'on',  ...
    'MaxFunEvals',     15000, ...
    'TolX',            1e-3, ...
    'GradConstr',      'off',...
    'TolCon',           10^-3,...
    'MaxIter',          5000,...
    'TolFun',           10^-3);

% ms = MultiStart('UseParallel',false);
    ms = MultiStart('UseParallel','never');

%     obj = @(theta2) gmmobj_3(theta2,x1,x2,s_vec,IV,v,T,J,K,ns,wmat);
obj = @(theta2) gmmobj_fixedtol_2(theta2,x1,x2,s_vec,IV,v,T_new,J,K,ns,wmat,mvalold,oldt2);

lb = zeros(size(theta2_0));
ub = 3*ones(size(theta2_0));

problem = createOptimProblem('fmincon','objective',obj,'x0',theta2_0,'options',options,'lb',lb,'ub',ub);

[theta2_BLP,fval_BLP,flag_BLP] = run(ms,problem,nx0);

delta_est = meanval_2(theta2_BLP,v,x2,s_vec,T_new,J,ns,mvalold,oldt2);
temp1 = x1'*IV;
temp2 = delta_est'*IV;
theta1_BLP = inv(temp1*wmat*temp1')*temp1*wmat*temp2';

end

