function [theta1_BLP,theta2_BLP,fval_BLP,flag_BLP,V_BLP] = fun_estimation_BLP_fixedtol_knitro(data,ns,K,J,theta2_0,T_new)

v = randn(ns,K+1);

x1 = [ones(T_new*J,1) data.p(:) data.x(:)];     % T*J - by - H; first all observations for good 1, then good 2 and so on...
% x1 = [kron(eye(J),ones(T_new,1)) data.p(:) data.x(:)];     % T*J - by - H+J; first all observations for good 1, then good 2 and so on...
x2 = [data.p(:) data.x(:)];
s_vec = data.s(:);
IV = [repmat(data.z,[J,1]) repmat(data.z.^2,[J,1])...
    repmat(data.x,[J,1]) repmat(data.x.^2,[J,1])...
    repmat(prod(data.x,2),[J,1]) repmat(data.x.*data.z,[J,1]) ones(T_new*J,1)];
% IV = [repmat(data.z,[J,1]) repmat(data.z.^2,[J,1]) repmat(data.x,[J,1]) repmat(prod(data.x,2),[J,1])];
% IV = [repmat(data.z,[J,1]) repmat(data.z.^2,[J,1]) repmat(data.x,[J,1]) repmat(prod(data.x,2),[J,1]) repmat(sum((data.x).^2,2),[J,1])];
M = size(IV,2);      % M = number of IV
wmat = inv([IV'*IV]);

s0 = 1.0-sum(data.s,2);

y = log(s_vec) - repmat(log(s0),[2,1]);
mid = x1'*IV*wmat*IV';
t = inv(mid*x1)*mid*y;
mvalold = x1*t;
oldt2 = zeros(size(theta2_0));
mvalold = exp(mvalold);

% save mvalold mvalold oldt2
%     clear mid y outshr t oldt2 mvalold temp sum1

% theta2_0 = theta2_true';
% [ theta2_0 ] = rand(nx0,length(theta2_true))*2;
% theta2_0 = [theta2_true';
%             theta2_0];
% initial_pts = CustomStartPointSet(theta2_0);

options = optimset('Algorithm',       'interior-point', ...
            'Display',         'none', ...
            'DerivativeCheck', 'off', ...
            'Hessian',         'bfgs', ...
            'GradObj',         'on',  ...
            'MaxFunEvals',     15000, ...
            'TolX',            1e-6, ...
            'GradConstr',      'off',...
            'TolCon',           10^-3,...
            'MaxIter',          1000,...
            'TolFun',           10^-3,...
            'FinDiffRelStep',   10^-1);

obj = @(theta2) gmmobj_fixedtol(theta2,x1,x2,s_vec,IV,v,T_new,J,K,ns,wmat,mvalold,oldt2);

lb = zeros(length(theta2_0),1);
ub = 5*ones(length(theta2_0),1);

[theta2_BLP,fval_BLP,flag_BLP] = knitromatlab(obj,theta2_0,[],[],[],[],lb,ub,[],[],options,'knitro_opt.txt');

delta_est = meanval_2(theta2_BLP,v,x2,s_vec,T_new,J,ns,mvalold,oldt2);
temp1 = x1'*IV;
temp2 = delta_est'*IV;
theta1_BLP = inv(temp1*wmat*temp1')*temp1*wmat*temp2';

expmval_est = exp(delta_est);
resid_vec = delta_est - x1*theta1_BLP;
V_BLP = var_cov_2(theta2_BLP,expmval_est,resid_vec,x1,x2,IV,T_new,J,K,v,ns,wmat);

end

