function [theta_NPD,fval_NPD,flag_NPD] = fun_estimation_NPD_2(data_trans,m_regr,m_IV,nIV,option_exch,option_symm)

% NB: this allows for different values of m for s and p, but withjin each
% group m must be the same across goods

warning('off','MATLAB:nargchk:deprecated');

T1 = size(data_trans{1},1);
T2 = size(data_trans{2},1);

%% preparation

B_s{1} = single(zeros(T1,prod(m_regr+1)));
B_IV_final{1} = single(zeros(T1,(m_IV+1)^nIV));

B_s{2} = single(zeros(T2,prod(m_regr+1)));
B_IV_final{2} = single(zeros(T2,(m_IV+1)^nIV));

ngrid_s_nonl = [2 2];
ngrid_p_nonl = [2 2];

[combos_s2,combos_p2,combos_s1_s2,combos_p1_p2,combos_all,combos_IV,nonlin_s,nonlin_p] = combinations_2(m_regr,m_IV,ngrid_s_nonl,ngrid_p_nonl,data_trans,nIV);

%% constraints

temp_mat = zeros(m_regr(1)+1,m_regr(2)+1,m_regr(3)+1,m_regr(4)+1);
temp_mat2 = zeros(m_regr(1)+1,m_regr(2)+1,m_regr(3)+1,m_regr(4)+1,2);

[ A_ineq,A_eq,b_ineq,b_eq ] = constraint_mat_theta_2(combos_s2,combos_p2,combos_s1_s2,combos_p1_p2,combos_all,temp_mat,temp_mat2,m_regr,option_exch,option_symm);
ntheta = size(A_ineq,2);

%% estimation

B_IV_final{1} = B_IV_fun(data_trans{1},combos_IV,m_IV);
B_s{1} = B_s_fun_2(data_trans{1},combos_all,m_regr);

B_IV_final{2} = B_IV_fun(data_trans{2},combos_IV,m_IV);
B_s{2} = B_s_fun_2(data_trans{2},combos_all,m_regr);

temp = B_IV_final{1}'*B_IV_final{1};
w_mat{1} = inv(temp + 0.05*eye(size(temp)));

temp = B_IV_final{2}'*B_IV_final{2};
w_mat{2} = inv(temp + 0.05*eye(size(temp)));

ub = 100;
lb = -100;

% hessian_fun = @(x,lambda_hess) hessianfcn_2(x,lambda_hess,B_s,B_IV_final,w_mat,combos_s,combos_p,J,m_regr,ntheta,ngamma,combos_all_unique,combos_perms);

fun_criterion = @(x) estimation_criterion(x,data_trans,w_mat,B_s,B_IV_final);

if strcmp(option_exch,'yes') || strcmp(option_symm,'yes')
    
    cvx_begin quiet
    
    cvx_precision default
    variable theta_temp(ntheta,1)
    
    x = reshape(theta_temp,[numel(theta_temp),1]);
    
    minimize( fun_criterion(x) )
    subject to
    A_ineq*x <= b_ineq
    A_eq*x == b_eq
    x<=ub
    x>=lb
    
    cvx_end
    
else    % i.e. if A_eq = []
    
    cvx_begin quiet
    
    cvx_precision default
    variable theta_temp(ntheta,1)
    
    x = reshape(theta_temp,[numel(theta_temp),1]);
    
    minimize( fun_criterion(x) )
    subject to
    A_ineq*x <= b_ineq
    x<=ub
    x>=lb
    
    cvx_end
    
end

theta_NPD = theta_temp;
fval_NPD = cvx_optval;
flag_NPD = cvx_status;

end
