function data = generate_data_simple_2z(T,rc_draw,gamma,J,constant)

x = rand(T,J)*2;
csi = randn(T,J)*0.15 + constant;
z = rand(T,J);  % IV: one for each product

p = gamma*(z + rand(T,J)*0.1) + csi;

s = zeros(T,J);

for t=1:T
    
    x_t = x(t,:);
    csi_t = csi(t,:);
    s(t,1) = share_fun_BLP(p(t,1),p(t,2),x_t,csi_t,rc_draw);
    s(t,2) = share_fun_BLP(p(t,2),p(t,1),x_t([2 1]),csi_t([2 1]),rc_draw);
    
end

data.x = x;
data.z = z;
data.s = s;
data.p = p;
data.csi = csi;
% data.delta = alpha_mu*data.p + beta_mu*data.x + data.csi; % don't really
% have the standard mean utility in this model with non-normal rc

data = struct2dataset(data);

data_temp = double(data);
ind = any(isnan(data_temp),2);      % get rid of NaN's that occur if computation of eq prices takes too long

data(ind,:) = [];

end






