function data = generate_data_simple_BLP(T,rc_draws,eta,constant)

% w is a 2-vector with the coefficients on the quadratic and cubic term on
% p (w<=0 ensures that the overall p coefficients are negative and implies that as p increases people get more price sensitive)

x_own = rand(T,2)*2;
csi_own = randn(T,2)*0.15 + constant;
z_own = rand(T,2)*1;

p_own = eta*(z_own + rand(T,2)*0.1) + csi_own;
% p_own = gamma*([mean(z_own(:,1:2),2) mean(z_own(:,3:4),2)] + rand(T,2)*0.1);

s_own = zeros(T,2);

for t=1:T
    %t
    
    s_own(t,1) = share_fun_inattention(p_own(t,1),p_own(t,2),x_own(t,:),csi_own(t,:),rc_draws,1);
    s_own(t,2) = share_fun_inattention(p_own(t,2),p_own(t,1),x_own(t,[2 1]),csi_own(t,[2 1]),rc_draws,2);
    
end

data.x = x_own;
data.z = z_own;
data.s = s_own;
data.p = p_own;
data.csi = csi_own;

data = struct2dataset(data);

data_temp = double(data);
ind = any(isnan(data_temp),2);      % get rid of NaN's that occur if computation of eq prices takes too long

data(ind,:) = [];

end






