function data = generate_data_simple_complements(T,A,alpha,beta,eta,q0)

% w is a 2-vector with the coefficients on the quadratic and cubic term on
% p (w<=0 ensures that the overall p coefficients are negative and implies that as p increases people get more price sensitive)

x_own = rand(T,2)*2;
csi_own = randn(T,2)*0.15 + 2;
z_own = rand(T,2)*1;

p_own = max(eta*(z_own + rand(T,2)*0.1) + csi_own,0.1);
% p_own = gamma*([mean(z_own(:,1:2),2) mean(z_own(:,3:4),2)] + rand(T,2)*0.1);

q_own = zeros(T,2);

for t=1:T
    %t
    
    q_own(t,1) = q_fun_complements(p_own(t,1),p_own(t,2),x_own(t,:),csi_own(t,:),A,alpha,beta);
    q_own(t,2) = q_fun_complements(p_own(t,2),p_own(t,1),x_own(t,[2 1]),csi_own(t,[2 1]),A,alpha,beta);
    
end

qsum = sum(q_own,2);
s_own = q_own./(q0+repmat(qsum,[1,2]));

data.x = x_own;
data.z = z_own;
data.q = q_own;
data.s = s_own;
data.p = p_own;
data.csi = csi_own;

data = struct2dataset(data);

data_temp = double(data);
ind = any(isnan(data_temp),2);      % get rid of NaN's that occur if computation of eq prices takes too long

data(ind,:) = [];

end






