function [f,grad] = gmmobj_fixedtol(theta2_0,x1,x2,s_vec,IV,v,T,J,K,ns,wmat,mvalold,oldt2)
% This function computes the GMM objective function

delta = meanval_fixedtol(theta2_0,v,x2,s_vec,T,J,ns,mvalold,oldt2);

% the following deals with cases where the min algorithm drifts into region where the objective is not defined
if max(isnan(delta)) == 1
    
    temp1 = x1'*IV;
    temp2 = delta'*IV;
    theta1 = inv(temp1*wmat*temp1')*temp1*wmat*temp2';
    clear temp1 temp2
    gmmresid = delta - x1*theta1;
    f = 1e+10;
    clear temp1
    
    grad = gradobj_2(theta2_0,gmmresid,wmat,x2,IV,v,exp(delta),T,J,K,ns);
    
else
    temp1 = x1'*IV;
    temp2 = delta'*IV;
    theta1 = inv(temp1*wmat*temp1')*temp1*wmat*temp2';
    clear temp1 temp2
    gmmresid = delta - x1*theta1;
    temp1 = gmmresid'*IV;
    f = temp1*wmat*temp1';
    clear temp1
    
    grad = gradobj_2(theta2_0,gmmresid,wmat,x2,IV,v,exp(delta),T,J,K,ns);
    
    %     save('gmmresid.mat','gmmresid')
end

disp(['GMM objective:  ' num2str(f)])

end


