function out = ind_sh_2(expmval,expmu,T,J)
% This function computes the "individual" probabilities of choosing each brand
% NB: expmval = exp(delta) is a (T*J - by - 1) vector
%     expmu = exp(mu) is a (T*J - by - ns) matrix
%     the outcome is a (T*J - by - ns) matrix

ns = size(expmu,2);

num = repmat(expmval,[1,ns]).*expmu;

expmval_r = reshape(expmval,[T,J]);     % T-by-J   
expmu_r = reshape(expmu,[T,J,ns]);
temp = repmat(expmval_r,[1,1,ns]).*expmu_r;
den_temp = 1+squeeze(sum(temp,2));      % T - by - ns
den = repmat(den_temp,[J,1,1]);

out = num./den;

% global ns cdindex cdid
% eg = expmu.*kron(ones(1,ns),expmval);
% temp = cumsum(eg); 
% sum1 = temp(cdindex,:);
% sum1(2:size(sum1,1),:) = diff(sum1);
% 
% denom1 = 1./(1+sum1);
% denom = denom1(cdid,:);
% f = eg.*denom;

end