function jac = jacob_2(expmval,theta2_0,ns,T,J,K,x2,v)
% This function computes the Jacobian of the implicit function that defines the mean utility

expmu = exp(mufunc_2(x2,theta2_0,v));
shares = ind_sh_2(expmval,expmu,T,J);

ds_dsigma = zeros(T*J,K+1);

% computing (partial share)/(partial sigma)
for i = 1:K+1
    
    x_i = x2(:,i);
    x_i_r = reshape(x_i,T,J);
    shares_r = reshape(shares,[T,J,ns]);
    
    xs_temp = squeeze(sum(repmat(x_i_r,[1,1,ns]).*shares_r,2));      % T-by-ns
    xs = repmat(xs_temp,[J,1]);                                      % T*J-by-ns
    
    temp = shares.*(repmat(x_i,[1,ns])-xs);
    
    ds_dsigma(:,i) = temp*v(:,i)/ns;
% 	clear xv temp sum1
end

% computing (partial delta)/(partial theta2)

jac = zeros(T*J,K+1);

% THIS ONLY WORKS FOR J=2!!!!!!!!!!!!!!!!!!!!!!

for t=1:T
    
     ds1_ddelta1 = (shares(t,:)*(1-shares(t,:))')/ns;
     ds2_ddelta2 = (shares(T+t,:)*(1-shares(T+t,:))')/ns;
     ds1_ddelta2 = -(shares(t,:)*shares(T+t,:)')/ns;            % equal to the other cross derivative
     ds2_ddelta1 = ds1_ddelta2;
     
     ds_ddelta = [ds1_ddelta1   ds1_ddelta2;
                  ds2_ddelta1   ds2_ddelta2];
              
     ds_dsigma_select = ds_dsigma([t T+t],:);
     
     jac([t T+t],:) = -inv(ds_ddelta)*ds_dsigma_select;
    
end

end
