function [ jacobian,gradient ] = jacobian_sigma_inv_p_2(theta_est,shares,prices,combos_all,m_regr)

%% good 1

J = 2;

theta{1} = theta_est(1:length(theta_est)/2);
theta{2} = theta_est(length(theta_est)/2+1:end);

jacobian = zeros(J);
gradient = cell(J,J);

for j=1:J
    
    indices = [j setdiff(1:J,j)];
    [~,position]=sort(indices);     % position(r) gives the position of the r-th good in the indices vector
    
    % differentiate wrt own good
    
    shares_reord = shares(indices);
    prices_reord = prices(indices);

    v_regr = combos_all-1;
    
    v_regr_minus1 = v_regr;
    v_regr_minus1(:,J+1) = v_regr_minus1(:,J+1)-1;
    
    v_regr_plus1 = v_regr;
    v_regr_plus1(:,J+1) = v_regr_plus1(:,J+1)+1;
    
    jacobian(j,j) = (prod(BernsteinElement_2(v_regr_minus1,m_regr,[shares_reord prices_reord]'),3).*(m_regr(J+1)-v_regr_minus1(:,J+1)) +...
        prod(BernsteinElement_2(v_regr,m_regr,[shares_reord prices_reord]'),3).*(2*v_regr(:,J+1)-m_regr(J+1)) -...
        prod(BernsteinElement_2(v_regr_plus1,m_regr,[shares_reord prices_reord]'),3).*v_regr_plus1(:,J+1))'*...
        theta{j};
    
    gradient{j,j} = (prod(BernsteinElement_2(v_regr_minus1,m_regr,[shares_reord prices_reord]'),3).*(m_regr(J+1)-v_regr_minus1(:,J+1)) +...
        prod(BernsteinElement_2(v_regr,m_regr,[shares_reord prices_reord]'),3).*(2*v_regr(:,J+1)-m_regr(J+1)) -...
        prod(BernsteinElement_2(v_regr_plus1,m_regr,[shares_reord prices_reord]'),3).*v_regr_plus1(:,J+1));
    
    % differentiate wrt other goods
    
    for k=setdiff(1:J,j)
        
        v_regr = combos_all-1;
        
        v_regr_minus1 = v_regr;
        v_regr_minus1(:,J+position(k)) = v_regr_minus1(:,J+position(k))-1;
        
        v_regr_plus1 = v_regr;
        v_regr_plus1(:,J+position(k)) = v_regr_plus1(:,J+position(k))+1;
        
        jacobian(j,k) = (prod(BernsteinElement_2(v_regr_minus1,m_regr,[shares_reord prices_reord]'),3).*(m_regr(J+position(k))-v_regr_minus1(:,J+position(k))) +...
            prod(BernsteinElement_2(v_regr,m_regr,[shares_reord prices_reord]'),3).*(2*v_regr(:,J+position(k))-m_regr(J+position(k))) -...
            prod(BernsteinElement_2(v_regr_plus1,m_regr,[shares_reord prices_reord]'),3).*v_regr_plus1(:,J+position(k)))'*...
            theta{j};
        
        gradient{j,k} = (prod(BernsteinElement_2(v_regr_minus1,m_regr,[shares_reord prices_reord]'),3).*(m_regr(J+position(k))-v_regr_minus1(:,J+position(k))) +...
            prod(BernsteinElement_2(v_regr,m_regr,[shares_reord prices_reord]'),3).*(2*v_regr(:,J+position(k))-m_regr(J+position(k))) -...
            prod(BernsteinElement_2(v_regr_plus1,m_regr,[shares_reord prices_reord]'),3).*v_regr_plus1(:,J+position(k)));
        
    end
    
end

end