function [ jacobian,gradient ] = jacobian_sigma_inv_s_J(theta,shares,m_regr,J,combos_all_unique,combos_perms)

%% good 1

s = 1;

jacobian = zeros(J);
gradient = cell(J,J);

for j=1:J
    
    indices = [j setdiff(1:J,j)];
    [~,position]=sort(indices);     % position(r) gives the position of the r-th good in the indices vector
    
    % differentiate wrt own good
    
    shares_reord = shares(indices);
    
    B_s_der = zeros(1,size(combos_all_unique,1));
    
    for i=1:size(combos_all_unique,1)
        
        combos_s_other = combos_perms{i};
        
%         for t=1:size(combos_s_other,1)
%             
%             [~,indices2] = sort(combos_s_other(t,:));
%             
%         end
        
        v_regr = double([repmat(combos_all_unique(i,1),[size(combos_s_other,1),1])   combos_s_other]) - 1;
        
        v_regr_minus1 = v_regr;
        v_regr_minus1(:,1) = v_regr_minus1(:,1)-1;
        
        v_regr_plus1 = v_regr;
        v_regr_plus1(:,1) = v_regr_plus1(:,1)+1;
        
        B_s_der(i) = sum((prod(BernsteinElement_2(v_regr_minus1,m_regr,[shares_reord]'),3).*(m_regr(1)-v_regr_minus1(:,1)) +...
            prod(BernsteinElement_2(v_regr,m_regr,[shares_reord]'),3).*(2*v_regr(:,1)-m_regr(1)) -...
            prod(BernsteinElement_2(v_regr_plus1,m_regr,[shares_reord]'),3).*v_regr_plus1(:,1))',2);
      %i  
    end
    
    jacobian(j,j) = B_s_der*theta(:,s);
    
    gradient{j,j} = B_s_der';
    
    % differentiate wrt other goods
    
    for k=setdiff(1:J,j)
        
        B_s_der = zeros(1,size(combos_all_unique,1));
        
        for i=1:size(combos_all_unique,1)
            
            combos_s_other = unique(perms(combos_all_unique(i,2:J)),'rows');
            
%             for t=1:size(combos_s_other,1)
%                 
%                 [~,indices3] = sort(combos_s_other(t,:));
%                 
%             end
            
            v_regr = double([repmat(combos_all_unique(i,1),[size(combos_s_other,1),1])   combos_s_other]) - 1;
            
            v_regr_minus1 = v_regr;
            v_regr_minus1(:,position(k)) = v_regr_minus1(:,position(k))-1;
            
            v_regr_plus1 = v_regr;
            v_regr_plus1(:,position(k)) = v_regr_plus1(:,position(k))+1;
            
            B_s_der(i) = sum((prod(BernsteinElement_2(v_regr_minus1,m_regr,[shares_reord]'),3).*(m_regr(position(k))-v_regr_minus1(:,position(k))) +...
                prod(BernsteinElement_2(v_regr,m_regr,[shares_reord]'),3).*(2*v_regr(:,position(k))-m_regr(position(k))) -...
                prod(BernsteinElement_2(v_regr_plus1,m_regr,[shares_reord]'),3).*v_regr_plus1(:,position(k)))',2);
        %i    
        end
        
        jacobian(j,k) = B_s_der*theta(:,s);
        
        gradient{j,k} = B_s_der';
        
    end
    
end

end