function f = meanval_2(theta2,v,x2,s_vec,T,J,ns,mvallogit,theta2logit)
% This function computes the mean utility level

% load('C:\Users\Giovanni\Dropbox\Nonparametric Demand\comparison\BLP\mvalold.mat')
% % load('mvalold.mat')

mvalold = mvallogit;
oldt2 = theta2logit;

if max(abs(theta2-oldt2)) < 0.01
    tol = 1e-13;
    flag = 0;
else
    tol = 1e-11;
    flag = 1;
end

expmu = exp(mufunc_2(x2,theta2,v));     % T*J-by-ns
norm = 1;
avgnorm = 1;

i = 0;
while norm > tol*10^(flag*floor(i/50)) && avgnorm > 1e-3*tol*10^(flag*floor(i/50))
    % the following two lines are equivalent; however, the latter saves on the number of exponents
    % computed at therefore speeds up the computation by 5-10%
    %  mval = mvalold + log(s_jt) - log(mktsh(mvalold,expmu));
    mval = mvalold.*s_vec./mktsh_2(mvalold,expmu,ns,T,J);       % T*J - by - 1
    
    t = abs(mval-mvalold);
    norm = max(t);
    avgnorm = mean(t);
    mvalold = mval;
    i = i + 1;
end
disp(['# of iterations for delta convergence:  ' num2str(i)])

if flag == 1 && max(isnan(mval)) < 1
    mvalold = mval;
    oldt2 = theta2;
%     save('mvalold.mat','mvalold','oldt2')
end
f = log(mval);

end
