function [ share_own ] = share_fun_BLP(p_own,p_other,x,csi,rc_draw)

% w is the coefficient on p in the mean of the r.c. for price, i.e. the
% mean is alpha_mu + w*p_own, with w < 0

p_own = reshape(p_own,[numel(p_own) 1]);
lp = length(p_own);

x_own = x(1);
x_other = x(2);

csi_own = csi(1);
csi_other = csi(2);

x_term_own = repmat(x_own,[lp,1])*rc_draw(2,:);
x_term_other = repmat(x_other,[lp,1])*rc_draw(2,:);

p_term_own = p_own.*rc_draw(1,:);
p_term_other = repmat(p_other,[lp,1]).*rc_draw(1,:);

util_own = bsxfun(@plus,x_term_own,p_term_own) + csi_own;
util_other = bsxfun(@plus,x_term_other,p_term_other) + csi_other;

temp_own = exp(util_own);
temp_other = exp(util_other);

share_own = temp_own./(1+temp_own+temp_other);                                   % (lp,N)

share_own = mean(share_own,2);

end