function [data_trans] = transform_data(data_temp,J)
% rearranges data, so that each observation has own/other (s,p,x,z)
% variables

data_trans = cell(J,1);

for j=1:J
    
    ind_temp = setdiff(1:J,j);
    
    data_trans{j}.x_own = data_temp.x(:,j);
    data_trans{j}.z = data_temp.z;
    data_trans{j}.s_own = data_temp.s(:,j);
    data_trans{j}.p_own = data_temp.p(:,j);
    data_trans{j}.x_other = data_temp.x(:,ind_temp);
    data_trans{j}.s_other = data_temp.s(:,ind_temp);
    data_trans{j}.p_other = data_temp.p(:,ind_temp);
    
    data_trans{j} = struct2dataset(data_trans{j});
    
end

end